From ac0b01bfca7d081862cdf659466c2459a435a259 Mon Sep 17 00:00:00 2001
From: Sinji Prasetio <sinjiprasetio@outlook.com>
Date: Sat, 27 Dec 2025 18:05:41 +0700
Subject: [PATCH 1/9] update

---
 0001-update.patch                             | 280 ++++++++++++++++++
 ...ckets_replace_prize_id_with_prize_name.php |  64 ++++
 2 files changed, 344 insertions(+)
 create mode 100644 0001-update.patch
 create mode 100644 database/migrations/2025_12_27_180431_update_tickets_replace_prize_id_with_prize_name.php

diff --git a/database/migrations/2025_12_27_180431_update_tickets_replace_prize_id_with_prize_name.php b/database/migrations/2025_12_27_180431_update_tickets_replace_prize_id_with_prize_name.php
new file mode 100644
index 0000000..938d967
--- /dev/null
+++ b/database/migrations/2025_12_27_180431_update_tickets_replace_prize_id_with_prize_name.php
@@ -0,0 +1,64 @@
+<?php
+
+use Illuminate\Database\Migrations\Migration;
+use Illuminate\Database\Schema\Blueprint;
+use Illuminate\Support\Facades\Schema;
+use Illuminate\Support\Facades\DB;
+
+return new class extends Migration
+{
+    /**
+     * Run the migrations.
+     */
+    public function up(): void
+    {
+        // 1. Tambah kolom prize_name (snapshot)
+        Schema::table('tickets', function (Blueprint $table) {
+            $table->string('prize_name')->nullable()->after('member_id');
+        });
+
+        // 2. Copy data dari prizes.prize ke tickets.prize_name
+        // (aman walau ada prize_id null)
+        DB::statement("
+            UPDATE tickets t
+            LEFT JOIN prizes p ON p.id = t.prize_id
+            SET t.prize_name = p.prize
+            WHERE t.prize_id IS NOT NULL
+        ");
+
+        // 3. Drop foreign key + kolom prize_id
+        Schema::table('tickets', function (Blueprint $table) {
+            // default Laravel FK name
+            $table->dropForeign(['prize_id']);
+            $table->dropColumn('prize_id');
+        });
+    }
+
+    /**
+     * Reverse the migrations.
+     */
+    public function down(): void
+    {
+        // 1. Balikin kolom prize_id
+        Schema::table('tickets', function (Blueprint $table) {
+            $table->foreignId('prize_id')
+                ->nullable()
+                ->after('member_id')
+                ->constrained()
+                ->onDelete('cascade');
+        });
+
+        // 2. Isi ulang prize_id dari prize_name (kalau nama masih sama)
+        DB::statement("
+            UPDATE tickets t
+            JOIN prizes p ON p.prize = t.prize_name
+            SET t.prize_id = p.id
+            WHERE t.prize_name IS NOT NULL
+        ");
+
+        // 3. Hapus snapshot
+        Schema::table('tickets', function (Blueprint $table) {
+            $table->dropColumn('prize_name');
+        });
+    }
+};
-- 
2.50.0


